#ifndef STRING_PARSER_IMPL_TEMPLATE_H_
#define STRING_PARSER_IMPL_TEMPLATE_H_

/*
 * $Id:$
 */

//##Documentation
//## Binds a special string parser class to class that implements string_parser_base.
template <class STR_PARSER_CLS, class STR_PARSER_BASE_IMPL>
class string_parser_impl_template : public STR_PARSER_CLS,
                                    public STR_PARSER_BASE_IMPL {
  public:
    string_parser_impl_template (const char* anonymous_arg) : STR_PARSER_BASE_IMPL (anonymous_arg) {}

    virtual std::string get_str () const { return STR_PARSER_BASE_IMPL::get_str (); }
    virtual ~string_parser_impl_template () {}
  private:
    string_parser_impl_template ();
    string_parser_impl_template (const string_parser_impl_template&);
    string_parser_impl_template& operator= (const string_parser_impl_template&);
};

#endif

