#ifndef COLLECTIONDUMPABLE_H
#define COLLECTIONDUMPABLE_H
#include"RACE_Dumpable.h"

//##ModelId=3F72A5C50166
//##Documentation
//##  Dumpable which keeps collections which can grow
//##

class RACE_CollectionDumpable : public virtual RACE_Dumpable
{
public:

    //##ModelId=3FB3861C02E7
  virtual ~RACE_CollectionDumpable () {}

    //##ModelId=3F72A5C503D9
  RACE_CollectionDumpable(size_t s):RACE_Dumpable(s) {}
//##ModelId=3F72A5C503DC
//##Documentation
//##  the number of entryies in the collection Container

  virtual size_t Count() = 0;
//##ModelId=3F72A5C503DF
//##Documentation
//##  the length of an entry

  virtual size_t GetEntryLength() = 0;
//##ModelId=3F72A5C503E1
//##Documentation
//##  allocates a new element at the end

  char *Append();

    //##ModelId=3F72A5C503E3
  virtual void SetTimestamp()=0;
protected:
    //##ModelId=3F72A5C503E6
  RACE_CollectionDumpable():RACE_Dumpable() {}
//##ModelId=3F72A5C60000
//##Documentation
//##  updates the internal data Structure

  virtual void AppendUpdate()=0;
};
#endif
