#include<time.h>
#include"RACE_LogIndexPositioner.h"

int main(int argc,char **argv)
{
  RACE_LogIndexPositioner positioner(argv[1]);
  if(positioner.IsEmpty())
  {
    printf("LogIndex is empty or not existent - the whole Logfile have to be read\n");
  }
  positioner.Print();
  try
  {
  RACE_LogfileOffset last = positioner.GetLastOffset();
  printf("LastOffset: %lu:%lu\n",last.part,last.offset);
  }
  catch(RACE_LogIndexPositioner::RangeError& ex)
  {
    fprintf(stderr,"%s\n",ex.What());
  }
  if(argc>2)
  {
    time_t wst=positioner.StrToTime(argv[2]);
    printf("Start bei index %lu\n",positioner.GetLastIndex(wst));
    try
    {
      printf("Offset: %lu:%lu\n",
             positioner[positioner.GetLastIndex(wst)].offset.part,
             positioner[positioner.GetLastIndex(wst)].offset.offset
             );
    }
    catch(RACE_LogIndexPositioner::RangeError& ex)
    {
      fprintf(stderr,"%s\n",ex.What());
    }
  }
}

