#include <iostream>
#include "env_access.h"

/*
 * $Id:$
*/

int main (int argc, char *argv[])
{
  if (argc != 2) {
    std::cerr << "usage: " << argv[0] << " <environment_variable>" << std::endl;
    return 1;
  }
  bool emptyEntriesRemoved;
  env_list my_list (argv[1]);
  string_list_parser::StringVector vec = my_list.splitAndPruneValues (emptyEntriesRemoved);

  std::cout << "emptyEntriesRemoved is " << emptyEntriesRemoved << std::endl;
  for (unsigned i = 0; i < vec.size (); i++) {
    std::cout << vec[i] << std::endl;
  }
  return 0;
}

